<?php

namespace Drupal\commerce_cib\Plugin\Commerce\PaymentGateway;

use Drupal\commerce_payment\Entity\PaymentInterface;

/**
 * Provides interface for the CIB payment gateway.
 */
interface CibInterface {

  /**
   * Create the CIB API request url based on the url query parameters.
   *
   * @param array $query
   *   An array of url query parameters.
   * @param string $market_customer
   *   Either 'market' or 'customer'.
   */
  public function createUrl(array $query, $market_customer = 'market');

  /**
   * Perform a 37 or 70 request.
   *
   * @param PaymentInterface $payment
   *   The payment entity to use for the request.$this
   * @param number $msgt
   *   The request message type: 37 or 70.
   *
   * @return array
   *   The response as an array.
   */
  public function msgt37Or70(PaymentInterface $payment, $msgt = 37);

}
